/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "cfparse.y"

/*
 * Configuration file parser for mrouted.
 *
 * Written by Bill Fenner, NRL, 1994
 *
 * cfparse.y,v 3.8.4.30 1998/03/01 01:48:58 fenner Exp
 */
#include <stdio.h>
#include <stdarg.h>
#include "defs.h"
#include <netdb.h>
#include <ifaddrs.h>

/*
 * Local function declarations
 */
static void        fatal(const char *fmt, ...);
static void        warn(const char *fmt, ...);
static void        yyerror(char *s);
static char       *next_word(void);
static int         yylex(void);
int                yyparse(void);

static FILE *fp;

int allow_black_holes = 0;

static int lineno;

static struct uvif *v;
static struct uvif scrap;

static int order, state;
static int noflood = 0;
static int rexmit = VIFF_REXMIT_PRUNES;

struct addrmask {
    uint32_t addr;
    int mask;
};

struct boundnam {
    char		*name;
    struct addrmask	 bound;
};

#define MAXBOUNDS 20

struct boundnam boundlist[MAXBOUNDS];	/* Max. of 20 named boundaries */
int numbounds = 0;			/* Number of named boundaries */


#line 125 "cfparse.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    CACHE_LIFETIME = 258,          /* CACHE_LIFETIME  */
    PRUNE_LIFETIME = 259,          /* PRUNE_LIFETIME  */
    PRUNING = 260,                 /* PRUNING  */
    BLACK_HOLE = 261,              /* BLACK_HOLE  */
    NOFLOOD = 262,                 /* NOFLOOD  */
    QUERY_INTERVAL = 263,          /* QUERY_INTERVAL  */
    QUERY_LAST_MEMBER_INTERVAL = 264, /* QUERY_LAST_MEMBER_INTERVAL  */
    IGMP_ROBUSTNESS = 265,         /* IGMP_ROBUSTNESS  */
    NO = 266,                      /* NO  */
    PHYINT = 267,                  /* PHYINT  */
    TUNNEL = 268,                  /* TUNNEL  */
    NAME = 269,                    /* NAME  */
    DISABLE = 270,                 /* DISABLE  */
    ENABLE = 271,                  /* ENABLE  */
    IGMPV1 = 272,                  /* IGMPV1  */
    IGMPV2 = 273,                  /* IGMPV2  */
    IGMPV3 = 274,                  /* IGMPV3  */
    STATIC_GROUP = 275,            /* STATIC_GROUP  */
    SRCRT = 276,                   /* SRCRT  */
    BESIDE = 277,                  /* BESIDE  */
    METRIC = 278,                  /* METRIC  */
    THRESHOLD = 279,               /* THRESHOLD  */
    RATE_LIMIT = 280,              /* RATE_LIMIT  */
    BOUNDARY = 281,                /* BOUNDARY  */
    NETMASK = 282,                 /* NETMASK  */
    ALTNET = 283,                  /* ALTNET  */
    ADVERT_METRIC = 284,           /* ADVERT_METRIC  */
    FILTER = 285,                  /* FILTER  */
    ACCEPT = 286,                  /* ACCEPT  */
    DENY = 287,                    /* DENY  */
    EXACT = 288,                   /* EXACT  */
    BIDIR = 289,                   /* BIDIR  */
    REXMIT_PRUNES = 290,           /* REXMIT_PRUNES  */
    REXMIT_PRUNES2 = 291,          /* REXMIT_PRUNES2  */
    PASSIVE = 292,                 /* PASSIVE  */
    ALLOW_NONPRUNERS = 293,        /* ALLOW_NONPRUNERS  */
    NOTRANSIT = 294,               /* NOTRANSIT  */
    BLASTER = 295,                 /* BLASTER  */
    FORCE_LEAF = 296,              /* FORCE_LEAF  */
    ROUTER_ALERT = 297,            /* ROUTER_ALERT  */
    PRUNE_LIFETIME2 = 298,         /* PRUNE_LIFETIME2  */
    NOFLOOD2 = 299,                /* NOFLOOD2  */
    SYSNAM = 300,                  /* SYSNAM  */
    SYSCONTACT = 301,              /* SYSCONTACT  */
    SYSVERSION = 302,              /* SYSVERSION  */
    SYSLOCATION = 303,             /* SYSLOCATION  */
    BOOLEAN = 304,                 /* BOOLEAN  */
    NUMBER = 305,                  /* NUMBER  */
    STRING = 306,                  /* STRING  */
    ADDRMASK = 307,                /* ADDRMASK  */
    ADDR = 308,                    /* ADDR  */
    GROUP = 309                    /* GROUP  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define CACHE_LIFETIME 258
#define PRUNE_LIFETIME 259
#define PRUNING 260
#define BLACK_HOLE 261
#define NOFLOOD 262
#define QUERY_INTERVAL 263
#define QUERY_LAST_MEMBER_INTERVAL 264
#define IGMP_ROBUSTNESS 265
#define NO 266
#define PHYINT 267
#define TUNNEL 268
#define NAME 269
#define DISABLE 270
#define ENABLE 271
#define IGMPV1 272
#define IGMPV2 273
#define IGMPV3 274
#define STATIC_GROUP 275
#define SRCRT 276
#define BESIDE 277
#define METRIC 278
#define THRESHOLD 279
#define RATE_LIMIT 280
#define BOUNDARY 281
#define NETMASK 282
#define ALTNET 283
#define ADVERT_METRIC 284
#define FILTER 285
#define ACCEPT 286
#define DENY 287
#define EXACT 288
#define BIDIR 289
#define REXMIT_PRUNES 290
#define REXMIT_PRUNES2 291
#define PASSIVE 292
#define ALLOW_NONPRUNERS 293
#define NOTRANSIT 294
#define BLASTER 295
#define FORCE_LEAF 296
#define ROUTER_ALERT 297
#define PRUNE_LIFETIME2 298
#define NOFLOOD2 299
#define SYSNAM 300
#define SYSCONTACT 301
#define SYSVERSION 302
#define SYSLOCATION 303
#define BOOLEAN 304
#define NUMBER 305
#define STRING 306
#define ADDRMASK 307
#define ADDR 308
#define GROUP 309

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 56 "cfparse.y"

    int num;
    char *ptr;
    struct addrmask addrmask;
    uint32_t addr, group;
    struct vf_element *filterelem;

#line 291 "cfparse.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);



/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_CACHE_LIFETIME = 3,             /* CACHE_LIFETIME  */
  YYSYMBOL_PRUNE_LIFETIME = 4,             /* PRUNE_LIFETIME  */
  YYSYMBOL_PRUNING = 5,                    /* PRUNING  */
  YYSYMBOL_BLACK_HOLE = 6,                 /* BLACK_HOLE  */
  YYSYMBOL_NOFLOOD = 7,                    /* NOFLOOD  */
  YYSYMBOL_QUERY_INTERVAL = 8,             /* QUERY_INTERVAL  */
  YYSYMBOL_QUERY_LAST_MEMBER_INTERVAL = 9, /* QUERY_LAST_MEMBER_INTERVAL  */
  YYSYMBOL_IGMP_ROBUSTNESS = 10,           /* IGMP_ROBUSTNESS  */
  YYSYMBOL_NO = 11,                        /* NO  */
  YYSYMBOL_PHYINT = 12,                    /* PHYINT  */
  YYSYMBOL_TUNNEL = 13,                    /* TUNNEL  */
  YYSYMBOL_NAME = 14,                      /* NAME  */
  YYSYMBOL_DISABLE = 15,                   /* DISABLE  */
  YYSYMBOL_ENABLE = 16,                    /* ENABLE  */
  YYSYMBOL_IGMPV1 = 17,                    /* IGMPV1  */
  YYSYMBOL_IGMPV2 = 18,                    /* IGMPV2  */
  YYSYMBOL_IGMPV3 = 19,                    /* IGMPV3  */
  YYSYMBOL_STATIC_GROUP = 20,              /* STATIC_GROUP  */
  YYSYMBOL_SRCRT = 21,                     /* SRCRT  */
  YYSYMBOL_BESIDE = 22,                    /* BESIDE  */
  YYSYMBOL_METRIC = 23,                    /* METRIC  */
  YYSYMBOL_THRESHOLD = 24,                 /* THRESHOLD  */
  YYSYMBOL_RATE_LIMIT = 25,                /* RATE_LIMIT  */
  YYSYMBOL_BOUNDARY = 26,                  /* BOUNDARY  */
  YYSYMBOL_NETMASK = 27,                   /* NETMASK  */
  YYSYMBOL_ALTNET = 28,                    /* ALTNET  */
  YYSYMBOL_ADVERT_METRIC = 29,             /* ADVERT_METRIC  */
  YYSYMBOL_FILTER = 30,                    /* FILTER  */
  YYSYMBOL_ACCEPT = 31,                    /* ACCEPT  */
  YYSYMBOL_DENY = 32,                      /* DENY  */
  YYSYMBOL_EXACT = 33,                     /* EXACT  */
  YYSYMBOL_BIDIR = 34,                     /* BIDIR  */
  YYSYMBOL_REXMIT_PRUNES = 35,             /* REXMIT_PRUNES  */
  YYSYMBOL_REXMIT_PRUNES2 = 36,            /* REXMIT_PRUNES2  */
  YYSYMBOL_PASSIVE = 37,                   /* PASSIVE  */
  YYSYMBOL_ALLOW_NONPRUNERS = 38,          /* ALLOW_NONPRUNERS  */
  YYSYMBOL_NOTRANSIT = 39,                 /* NOTRANSIT  */
  YYSYMBOL_BLASTER = 40,                   /* BLASTER  */
  YYSYMBOL_FORCE_LEAF = 41,                /* FORCE_LEAF  */
  YYSYMBOL_ROUTER_ALERT = 42,              /* ROUTER_ALERT  */
  YYSYMBOL_PRUNE_LIFETIME2 = 43,           /* PRUNE_LIFETIME2  */
  YYSYMBOL_NOFLOOD2 = 44,                  /* NOFLOOD2  */
  YYSYMBOL_SYSNAM = 45,                    /* SYSNAM  */
  YYSYMBOL_SYSCONTACT = 46,                /* SYSCONTACT  */
  YYSYMBOL_SYSVERSION = 47,                /* SYSVERSION  */
  YYSYMBOL_SYSLOCATION = 48,               /* SYSLOCATION  */
  YYSYMBOL_BOOLEAN = 49,                   /* BOOLEAN  */
  YYSYMBOL_NUMBER = 50,                    /* NUMBER  */
  YYSYMBOL_STRING = 51,                    /* STRING  */
  YYSYMBOL_ADDRMASK = 52,                  /* ADDRMASK  */
  YYSYMBOL_ADDR = 53,                      /* ADDR  */
  YYSYMBOL_GROUP = 54,                     /* GROUP  */
  YYSYMBOL_YYACCEPT = 55,                  /* $accept  */
  YYSYMBOL_conf = 56,                      /* conf  */
  YYSYMBOL_stmts = 57,                     /* stmts  */
  YYSYMBOL_stmt = 58,                      /* stmt  */
  YYSYMBOL_59_1 = 59,                      /* $@1  */
  YYSYMBOL_60_2 = 60,                      /* $@2  */
  YYSYMBOL_tunnelmods = 61,                /* tunnelmods  */
  YYSYMBOL_tunnelmod = 62,                 /* tunnelmod  */
  YYSYMBOL_ifmods = 63,                    /* ifmods  */
  YYSYMBOL_ifmod = 64,                     /* ifmod  */
  YYSYMBOL_mod = 65,                       /* mod  */
  YYSYMBOL_interface = 66,                 /* interface  */
  YYSYMBOL_addrname = 67,                  /* addrname  */
  YYSYMBOL_bound = 68,                     /* bound  */
  YYSYMBOL_boundary = 69,                  /* boundary  */
  YYSYMBOL_addrmask = 70,                  /* addrmask  */
  YYSYMBOL_filter = 71,                    /* filter  */
  YYSYMBOL_filtlist = 72,                  /* filtlist  */
  YYSYMBOL_filtelement = 73,               /* filtelement  */
  YYSYMBOL_filtelem = 74                   /* filtelem  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   106

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  55
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  20
/* YYNRULES -- Number of rules.  */
#define YYNRULES  87
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  107

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   309


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,    88,    88,    91,    92,    95,    96,    98,    97,   113,
     112,   146,   153,   160,   165,   169,   173,   184,   194,   203,
     210,   221,   225,   229,   233,   237,   243,   249,   257,   258,
     261,   262,   266,   273,   279,   280,   283,   284,   285,   286,
     287,   288,   289,   306,   318,   322,   347,   351,   355,   364,
     370,   374,   380,   384,   390,   394,   400,   404,   422,   426,
     430,   437,   441,   445,   449,   454,   458,   465,   492,   496,
     523,   527,   537,   541,   558,   562,   590,   594,   610,   623,
     624,   627,   628,   631,   632,   635,   636,   639
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "CACHE_LIFETIME",
  "PRUNE_LIFETIME", "PRUNING", "BLACK_HOLE", "NOFLOOD", "QUERY_INTERVAL",
  "QUERY_LAST_MEMBER_INTERVAL", "IGMP_ROBUSTNESS", "NO", "PHYINT",
  "TUNNEL", "NAME", "DISABLE", "ENABLE", "IGMPV1", "IGMPV2", "IGMPV3",
  "STATIC_GROUP", "SRCRT", "BESIDE", "METRIC", "THRESHOLD", "RATE_LIMIT",
  "BOUNDARY", "NETMASK", "ALTNET", "ADVERT_METRIC", "FILTER", "ACCEPT",
  "DENY", "EXACT", "BIDIR", "REXMIT_PRUNES", "REXMIT_PRUNES2", "PASSIVE",
  "ALLOW_NONPRUNERS", "NOTRANSIT", "BLASTER", "FORCE_LEAF", "ROUTER_ALERT",
  "PRUNE_LIFETIME2", "NOFLOOD2", "SYSNAM", "SYSCONTACT", "SYSVERSION",
  "SYSLOCATION", "BOOLEAN", "NUMBER", "STRING", "ADDRMASK", "ADDR",
  "GROUP", "$accept", "conf", "stmts", "stmt", "$@1", "$@2", "tunnelmods",
  "tunnelmod", "ifmods", "ifmod", "mod", "interface", "addrname", "bound",
  "boundary", "addrmask", "filter", "filtlist", "filtelement", "filtelem", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-37)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-3)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int8 yypact[] =
{
     -37,    25,     0,   -37,   -37,   -24,   -23,   -21,   -37,   -37,
     -20,   -19,   -17,   -10,   -36,   -36,   -22,   -15,   -13,   -14,
     -12,   -11,    -8,   -37,   -37,   -37,   -37,   -37,   -37,   -37,
     -37,   -37,   -37,   -37,   -37,   -35,     3,   -37,   -37,   -37,
     -37,   -37,   -37,   -37,   -37,   -37,   -37,   -37,   -37,    34,
     -37,   -37,   -37,   -37,   -37,   -37,   -16,    -9,    -6,     6,
     -32,   -35,   -31,    14,   -28,   -28,   -37,    18,   -37,   -37,
     -37,   -37,    20,    26,   -37,   -37,   -37,    58,   -37,   -37,
     -37,   -37,   -37,   -37,   -37,   -37,   -37,   -37,   -37,   -37,
     -37,   -37,   -37,   -37,    33,    53,   -37,   -37,   -37,   -37,
     -37,    39,   -37,   -37,   -37,   -37,   -37
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       3,     0,     0,     1,     5,     0,     0,     0,    16,    17,
       0,     0,     0,     0,     0,     0,     0,    18,     0,     0,
       0,     0,     0,     4,    11,    12,    13,    25,    26,    27,
       6,    14,    73,    72,     7,     0,     0,    19,    15,    21,
      22,    23,    24,    34,    75,    74,     9,    78,    20,     8,
      28,    37,    38,    39,    40,    41,     0,    52,    50,    56,
      58,    44,    46,    54,    68,    70,    71,    59,    61,    65,
      63,    64,    47,     0,    62,    35,    36,    10,    42,    51,
      49,    55,    77,    57,    76,    43,    79,    80,    45,    53,
      82,    87,    67,    81,    83,    85,    69,    60,    48,    66,
      33,    31,    29,    30,    84,    86,    32
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -37,   -37,   -37,   -37,   -37,   -37,   -37,   -37,   -37,   -37,
      16,    76,    38,   -37,    40,   -37,    41,     9,   -37,   -37
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,     1,     2,    23,    43,    50,    77,   102,    49,    75,
      76,    34,    46,    83,    48,    88,    92,    93,    94,    95
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
      -2,     4,    30,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    32,    44,    33,    45,    82,
      47,    86,    87,    90,    91,     3,    24,    25,    26,    36,
      27,    28,    31,    29,    37,    17,    38,    39,    78,    40,
      41,    79,    18,    42,    80,    19,    20,    21,    22,    51,
      52,    53,    54,    55,    56,    47,    81,    57,    58,    59,
      60,    61,    62,    63,    89,    64,    65,    97,    66,    98,
      67,    68,    69,    70,    71,    72,    99,    73,    74,   100,
     101,    57,    58,    59,    60,    91,   105,    63,   106,    64,
      65,    35,    66,   103,    67,    68,    69,    70,    71,    85,
      84,    73,    74,   104,     0,     0,    96
};

static const yytype_int8 yycheck[] =
{
       0,     1,    12,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    51,    51,    53,    53,    51,
      52,    52,    53,    51,    52,     0,    50,    50,    49,    51,
      50,    50,    42,    50,    49,    35,    49,    51,    54,    51,
      51,    50,    42,    51,    50,    45,    46,    47,    48,    15,
      16,    17,    18,    19,    20,    52,    50,    23,    24,    25,
      26,    27,    28,    29,    50,    31,    32,    49,    34,    49,
      36,    37,    38,    39,    40,    41,    50,    43,    44,    21,
      22,    23,    24,    25,    26,    52,    33,    29,    49,    31,
      32,    15,    34,    77,    36,    37,    38,    39,    40,    61,
      60,    43,    44,    94,    -1,    -1,    65
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    56,    57,     0,     1,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    35,    42,    45,
      46,    47,    48,    58,    50,    50,    49,    50,    50,    50,
      12,    42,    51,    53,    66,    66,    51,    49,    49,    51,
      51,    51,    51,    59,    51,    53,    67,    52,    69,    63,
      60,    15,    16,    17,    18,    19,    20,    23,    24,    25,
      26,    27,    28,    29,    31,    32,    34,    36,    37,    38,
      39,    40,    41,    43,    44,    64,    65,    61,    54,    50,
      50,    50,    51,    68,    69,    67,    52,    53,    70,    50,
      51,    52,    71,    72,    73,    74,    71,    49,    49,    50,
      21,    22,    62,    65,    72,    33,    49
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    55,    56,    57,    57,    58,    58,    59,    58,    60,
      58,    58,    58,    58,    58,    58,    58,    58,    58,    58,
      58,    58,    58,    58,    58,    58,    58,    58,    61,    61,
      62,    62,    62,    62,    63,    63,    64,    64,    64,    64,
      64,    64,    64,    64,    64,    64,    64,    64,    64,    65,
      65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
      65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
      65,    65,    66,    66,    67,    67,    68,    68,    69,    70,
      70,    71,    71,    72,    72,    73,    73,    74
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     0,     2,     1,     2,     0,     4,     0,
       5,     2,     2,     2,     2,     2,     1,     1,     1,     2,
       3,     2,     2,     2,     2,     2,     2,     2,     0,     2,
       1,     1,     2,     1,     0,     2,     1,     1,     1,     1,
       1,     1,     2,     2,     1,     2,     1,     1,     2,     2,
       1,     2,     1,     2,     1,     2,     1,     2,     1,     1,
       2,     1,     1,     1,     1,     1,     2,     2,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     2,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 6: /* stmt: NO PHYINT  */
#line 96 "cfparse.y"
                                { config_set_ifflag(VIFF_DISABLED); }
#line 1422 "cfparse.c"
    break;

  case 7: /* $@1: %empty  */
#line 98 "cfparse.y"
        {
	    state++;

	    if (order)
		fatal("phyints must appear before tunnels");

	    v = config_find_ifaddr((yyvsp[0].addr));
	    if (!v) {
		if ((yyvsp[0].addr) != 0)
		    warn("phyint %s not available, continuing ...", inet_fmt((yyvsp[0].addr), s1, sizeof(s1)));
		v = &scrap;
	    }
	}
#line 1440 "cfparse.c"
    break;

  case 9: /* $@2: %empty  */
#line 113 "cfparse.y"
        {
	    order++;
	    v = config_init_tunnel((yyvsp[-1].addr), (yyvsp[0].addr), rexmit | noflood);
	    if (!v) {
		switch (errno) {
		case ENOTMINE:
		    fatal("Tunnel local address %s is not mine", inet_fmt((yyvsp[-1].addr), s1, sizeof(s1)));
		    break;
		case ELOOPBACK:
		    fatal("Tunnel local address %s is a loopback address",
			  inet_fmt((yyvsp[-1].addr), s1, sizeof(s1)));
		    break;
		case ERMTLOCAL:
		    fatal("Tunnel remote address %s is one of mine",
			  inet_fmt((yyvsp[0].addr), s1, sizeof(s1)));
		    break;
		case EDUPLICATE:
		    fatal("Duplicate tunnel to %s", inet_fmt((yyvsp[0].addr), s1, sizeof(s1)));
		    break;
		default:
		    /* Log file and line number at least */
		    fatal("");
		    break;
		}

		v = &scrap;
	    }
	}
#line 1473 "cfparse.c"
    break;

  case 10: /* stmt: TUNNEL interface addrname $@2 tunnelmods  */
#line 142 "cfparse.y"
        {
	    if (!(v->uv_flags & VIFF_OTUNNEL))
		init_ipip_on_vif(v);
	}
#line 1482 "cfparse.c"
    break;

  case 11: /* stmt: CACHE_LIFETIME NUMBER  */
#line 147 "cfparse.y"
        {
	    if ((yyvsp[0].num) < MIN_CACHE_LIFETIME)
		warn("cache-lifetime %d must be at least %d", (yyvsp[0].num), MIN_CACHE_LIFETIME);
	    else
		cache_lifetime = (yyvsp[0].num);
	}
#line 1493 "cfparse.c"
    break;

  case 12: /* stmt: PRUNE_LIFETIME NUMBER  */
#line 154 "cfparse.y"
        {
	    if ((yyvsp[0].num) < MIN_PRUNE_LIFETIME)
		warn("prune-lifetime %d must be at least %d", (yyvsp[0].num), MIN_PRUNE_LIFETIME);
	    else
		prune_lifetime = (yyvsp[0].num);
	}
#line 1504 "cfparse.c"
    break;

  case 13: /* stmt: PRUNING BOOLEAN  */
#line 161 "cfparse.y"
        {
	    if ((yyvsp[0].num) != 1)
		warn("Disabling pruning is no longer supported");
	}
#line 1513 "cfparse.c"
    break;

  case 14: /* stmt: NO ROUTER_ALERT  */
#line 166 "cfparse.y"
        {
	    router_alert = 0;
	}
#line 1521 "cfparse.c"
    break;

  case 15: /* stmt: ROUTER_ALERT BOOLEAN  */
#line 170 "cfparse.y"
        {
	    router_alert = (yyvsp[0].num);
	}
#line 1529 "cfparse.c"
    break;

  case 16: /* stmt: BLACK_HOLE  */
#line 174 "cfparse.y"
        {
#ifdef ALLOW_BLACK_HOLES
	    allow_black_holes = 1;
#endif
	}
#line 1539 "cfparse.c"
    break;

  case 17: /* stmt: NOFLOOD  */
#line 185 "cfparse.y"
        {
	    noflood = VIFF_NOFLOOD;
	    config_set_ifflag(VIFF_NOFLOOD);
	}
#line 1548 "cfparse.c"
    break;

  case 18: /* stmt: REXMIT_PRUNES  */
#line 195 "cfparse.y"
        {
	    config_set_ifflag(VIFF_REXMIT_PRUNES);
	}
#line 1556 "cfparse.c"
    break;

  case 19: /* stmt: REXMIT_PRUNES BOOLEAN  */
#line 204 "cfparse.y"
        {
	    if ((yyvsp[0].num))
		config_set_ifflag(VIFF_REXMIT_PRUNES);
	    else
		rexmit = 0;
	}
#line 1567 "cfparse.c"
    break;

  case 20: /* stmt: NAME STRING boundary  */
#line 211 "cfparse.y"
        {
	    size_t len = strlen((yyvsp[-1].ptr)) + 1;

	    if (numbounds >= MAXBOUNDS)
		fatal("Too many named boundaries (max %d)", MAXBOUNDS);

	    boundlist[numbounds].name = malloc(len);
	    strlcpy(boundlist[numbounds].name, (yyvsp[-1].ptr), len);
	    boundlist[numbounds++].bound = (yyvsp[0].addrmask);
	}
#line 1582 "cfparse.c"
    break;

  case 21: /* stmt: SYSNAM STRING  */
#line 222 "cfparse.y"
        {
	    /* Removed SNMP support */
	}
#line 1590 "cfparse.c"
    break;

  case 22: /* stmt: SYSCONTACT STRING  */
#line 226 "cfparse.y"
        {
	    /* Removed SNMP support */
	}
#line 1598 "cfparse.c"
    break;

  case 23: /* stmt: SYSVERSION STRING  */
#line 230 "cfparse.y"
        {
	    /* Removed SNMP support */
	}
#line 1606 "cfparse.c"
    break;

  case 24: /* stmt: SYSLOCATION STRING  */
#line 234 "cfparse.y"
        {
	    /* Removed SNMP support */
	}
#line 1614 "cfparse.c"
    break;

  case 25: /* stmt: QUERY_INTERVAL NUMBER  */
#line 238 "cfparse.y"
        {
	    if ((yyvsp[0].num) < 1 || (yyvsp[0].num) > 1024)
		fatal("Invalid IGMP query interval [1,1024]: %d", (yyvsp[0].num));
	    igmp_query_interval = (yyvsp[0].num);
	}
#line 1624 "cfparse.c"
    break;

  case 26: /* stmt: QUERY_LAST_MEMBER_INTERVAL NUMBER  */
#line 244 "cfparse.y"
        {
	    if ((yyvsp[0].num) < 1 || (yyvsp[0].num) > 1024)
		fatal("Invalid IGMP query interval [1,1024]: %d", (yyvsp[0].num));
	    igmp_last_member_interval = (yyvsp[0].num);
	}
#line 1634 "cfparse.c"
    break;

  case 27: /* stmt: IGMP_ROBUSTNESS NUMBER  */
#line 250 "cfparse.y"
        {
	    if ((yyvsp[0].num) < 2 || (yyvsp[0].num) > 10)
		fatal("Invalid IGMP robustness value [2,10]: %d", (yyvsp[0].num));
	    igmp_robustness = (yyvsp[0].num);
	}
#line 1644 "cfparse.c"
    break;

  case 31: /* tunnelmod: BESIDE  */
#line 263 "cfparse.y"
        {
	    v->uv_flags |= VIFF_OTUNNEL;
	}
#line 1652 "cfparse.c"
    break;

  case 32: /* tunnelmod: BESIDE BOOLEAN  */
#line 267 "cfparse.y"
        {
	    if ((yyvsp[0].num))
		v->uv_flags |= VIFF_OTUNNEL;
	    else
		v->uv_flags &= ~VIFF_OTUNNEL;
	}
#line 1663 "cfparse.c"
    break;

  case 33: /* tunnelmod: SRCRT  */
#line 274 "cfparse.y"
        {
	    fatal("Source-route tunnels not supported");
	}
#line 1671 "cfparse.c"
    break;

  case 37: /* ifmod: DISABLE  */
#line 284 "cfparse.y"
                                { v->uv_flags |= VIFF_DISABLED; }
#line 1677 "cfparse.c"
    break;

  case 38: /* ifmod: ENABLE  */
#line 285 "cfparse.y"
                                { v->uv_flags &= ~VIFF_DISABLED; }
#line 1683 "cfparse.c"
    break;

  case 39: /* ifmod: IGMPV1  */
#line 286 "cfparse.y"
                                { v->uv_flags &= ~VIFF_IGMPV2; v->uv_flags |= VIFF_IGMPV1; }
#line 1689 "cfparse.c"
    break;

  case 40: /* ifmod: IGMPV2  */
#line 287 "cfparse.y"
                                { v->uv_flags &= ~VIFF_IGMPV1; v->uv_flags |= VIFF_IGMPV2; }
#line 1695 "cfparse.c"
    break;

  case 41: /* ifmod: IGMPV3  */
#line 288 "cfparse.y"
                                { v->uv_flags &= ~VIFF_IGMPV1; v->uv_flags &= ~VIFF_IGMPV2; }
#line 1701 "cfparse.c"
    break;

  case 42: /* ifmod: STATIC_GROUP GROUP  */
#line 290 "cfparse.y"
        {
	    struct listaddr *a;

	    a = calloc(1, sizeof(struct listaddr));
	    if (!a) {
		fatal("Failed allocating memory for 'struct listaddr'");
		return 0;
	    }

	    a->al_addr  = (yyvsp[0].addr);
	    a->al_pv    = 2;	/* IGMPv2 only, no SSM */
	    a->al_flags = NBRF_STATIC_GROUP;
	    time(&a->al_ctime);

	    TAILQ_INSERT_TAIL(&v->uv_static, a, al_link);
	}
#line 1722 "cfparse.c"
    break;

  case 43: /* ifmod: NETMASK addrname  */
#line 307 "cfparse.y"
        {
	    uint32_t subnet, mask;

	    mask = (yyvsp[0].addr);
	    subnet = v->uv_lcl_addr & mask;
	    if (!inet_valid_subnet(subnet, mask))
		fatal("Invalid netmask");
	    v->uv_subnet = subnet;
	    v->uv_subnetmask = mask;
	    v->uv_subnetbcast = subnet | ~mask;
	}
#line 1738 "cfparse.c"
    break;

  case 44: /* ifmod: NETMASK  */
#line 319 "cfparse.y"
        {
	    warn("Expected address after netmask keyword, ignored");
	}
#line 1746 "cfparse.c"
    break;

  case 45: /* ifmod: ALTNET addrmask  */
#line 323 "cfparse.y"
        {
	    struct phaddr *ph;

	    ph = calloc(1, sizeof(struct phaddr));
	    if (!ph) {
		fatal("Failed allocating memory for 'struct phaddr'");
		return 0;
	    }

	    if ((yyvsp[0].addrmask).mask)
		VAL_TO_MASK(ph->pa_subnetmask, (yyvsp[0].addrmask).mask);
	    else
		ph->pa_subnetmask = v->uv_subnetmask;

	    ph->pa_subnet = (yyvsp[0].addrmask).addr & ph->pa_subnetmask;
	    ph->pa_subnetbcast = ph->pa_subnet | ~ph->pa_subnetmask;

	    if ((yyvsp[0].addrmask).addr & ~ph->pa_subnetmask)
		warn("Extra subnet %s/%d has host bits set",
		     inet_fmt((yyvsp[0].addrmask).addr, s1, sizeof(s1)), (yyvsp[0].addrmask).mask);

	    ph->pa_next = v->uv_addrs;
	    v->uv_addrs = ph;
	}
#line 1775 "cfparse.c"
    break;

  case 46: /* ifmod: ALTNET  */
#line 348 "cfparse.y"
        {
	    warn("Expected address after altnet keyword, ignored");
	}
#line 1783 "cfparse.c"
    break;

  case 47: /* ifmod: FORCE_LEAF  */
#line 352 "cfparse.y"
        {
	    v->uv_flags |= VIFF_FORCE_LEAF;
	}
#line 1791 "cfparse.c"
    break;

  case 48: /* ifmod: FORCE_LEAF BOOLEAN  */
#line 356 "cfparse.y"
        {
	    if ((yyvsp[0].num))
		v->uv_flags |= VIFF_FORCE_LEAF;
	    else
		v->uv_flags &= ~VIFF_FORCE_LEAF;
	}
#line 1802 "cfparse.c"
    break;

  case 49: /* mod: THRESHOLD NUMBER  */
#line 365 "cfparse.y"
        {
	    if ((yyvsp[0].num) < 1 || (yyvsp[0].num) > 255)
		fatal("Invalid threshold %d",(yyvsp[0].num));
	    v->uv_threshold = (yyvsp[0].num);
	}
#line 1812 "cfparse.c"
    break;

  case 50: /* mod: THRESHOLD  */
#line 371 "cfparse.y"
        {
	    warn("Expected number after threshold keyword, ignored");
	}
#line 1820 "cfparse.c"
    break;

  case 51: /* mod: METRIC NUMBER  */
#line 375 "cfparse.y"
        {
	    if ((yyvsp[0].num) < 1 || (yyvsp[0].num) > UNREACHABLE)
		fatal("Invalid metric %d",(yyvsp[0].num));
	    v->uv_metric = (yyvsp[0].num);
	}
#line 1830 "cfparse.c"
    break;

  case 52: /* mod: METRIC  */
#line 381 "cfparse.y"
        {
	    warn("Expected number after metric keyword, ignored");
	}
#line 1838 "cfparse.c"
    break;

  case 53: /* mod: ADVERT_METRIC NUMBER  */
#line 385 "cfparse.y"
        {
	    if ((yyvsp[0].num) < 0 || (yyvsp[0].num) > UNREACHABLE - 1)
		fatal("Invalid advert-metric %d", (yyvsp[0].num));
	    v->uv_admetric = (yyvsp[0].num);
	}
#line 1848 "cfparse.c"
    break;

  case 54: /* mod: ADVERT_METRIC  */
#line 391 "cfparse.y"
        {
	    warn("Expected number after advert-metric keyword, ignored");
	}
#line 1856 "cfparse.c"
    break;

  case 55: /* mod: RATE_LIMIT NUMBER  */
#line 395 "cfparse.y"
        {
	    if ((yyvsp[0].num) > MAX_RATE_LIMIT)
		fatal("Invalid rate-limit %d",(yyvsp[0].num));
	    v->uv_rate_limit = (yyvsp[0].num);
	}
#line 1866 "cfparse.c"
    break;

  case 56: /* mod: RATE_LIMIT  */
#line 401 "cfparse.y"
        {
	    warn("Expected number after rate-limit keyword, ignored");
	}
#line 1874 "cfparse.c"
    break;

  case 57: /* mod: BOUNDARY bound  */
#line 405 "cfparse.y"
        {
	    struct vif_acl *v_acl;

	    v_acl = calloc(1, sizeof(struct vif_acl));
	    if (!v_acl) {
		fatal("Failed allocating memory for 'struct vif_acl'");
		return 0;
	    }

	    VAL_TO_MASK(v_acl->acl_mask, (yyvsp[0].addrmask).mask);
	    v_acl->acl_addr = (yyvsp[0].addrmask).addr & v_acl->acl_mask;
	    if ((yyvsp[0].addrmask).addr & ~v_acl->acl_mask)
		warn("Boundary spec %s/%d has host bits set",
		     inet_fmt((yyvsp[0].addrmask).addr, s1, sizeof(s1)), (yyvsp[0].addrmask).mask);
	    v_acl->acl_next = v->uv_acl;
	    v->uv_acl = v_acl;
	}
#line 1896 "cfparse.c"
    break;

  case 58: /* mod: BOUNDARY  */
#line 423 "cfparse.y"
        {
	    warn("Expected boundary spec after boundary keyword, ignored");
	}
#line 1904 "cfparse.c"
    break;

  case 59: /* mod: REXMIT_PRUNES2  */
#line 427 "cfparse.y"
        {
	    v->uv_flags |= VIFF_REXMIT_PRUNES;
	}
#line 1912 "cfparse.c"
    break;

  case 60: /* mod: REXMIT_PRUNES2 BOOLEAN  */
#line 431 "cfparse.y"
        {
	    if ((yyvsp[0].num))
		v->uv_flags |= VIFF_REXMIT_PRUNES;
	    else
		v->uv_flags &= ~VIFF_REXMIT_PRUNES;
	}
#line 1923 "cfparse.c"
    break;

  case 61: /* mod: PASSIVE  */
#line 438 "cfparse.y"
        {
	    v->uv_flags |= VIFF_PASSIVE;
	}
#line 1931 "cfparse.c"
    break;

  case 62: /* mod: NOFLOOD2  */
#line 442 "cfparse.y"
        {
	    v->uv_flags |= VIFF_NOFLOOD;
	}
#line 1939 "cfparse.c"
    break;

  case 63: /* mod: NOTRANSIT  */
#line 446 "cfparse.y"
        {
	    v->uv_flags |= VIFF_NOTRANSIT;
	}
#line 1947 "cfparse.c"
    break;

  case 64: /* mod: BLASTER  */
#line 450 "cfparse.y"
        {
	    v->uv_flags |= VIFF_BLASTER;
	    blaster_alloc(v);
	}
#line 1956 "cfparse.c"
    break;

  case 65: /* mod: ALLOW_NONPRUNERS  */
#line 455 "cfparse.y"
        {
	    v->uv_flags |= VIFF_ALLOW_NONPRUNERS;
	}
#line 1964 "cfparse.c"
    break;

  case 66: /* mod: PRUNE_LIFETIME2 NUMBER  */
#line 459 "cfparse.y"
        {
	    if ((yyvsp[0].num) < MIN_PRUNE_LIFETIME)
		warn("prune-lifetime %d must be at least %d", (yyvsp[0].num), MIN_PRUNE_LIFETIME);
	    else
		v->uv_prune_lifetime = (yyvsp[0].num);
	}
#line 1975 "cfparse.c"
    break;

  case 67: /* mod: ACCEPT filter  */
#line 466 "cfparse.y"
        {
	    if (v->uv_filter == NULL) {
		struct vif_filter *v_filter;

		v_filter = calloc(1, sizeof(struct vif_filter));
		if (!v_filter) {
		    fatal("Failed allocating memory for 'struct vif_filter'");
		    return 0;
		}

		v_filter->vf_flags  = 0;
		v_filter->vf_type   = VFT_ACCEPT;
		v_filter->vf_filter = (yyvsp[0].filterelem);

		v->uv_filter = v_filter;
	    } else if (v->uv_filter->vf_type != VFT_ACCEPT) {
		fatal("Cannot accept and deny");
	    } else {
		struct vf_element *p;

		p = v->uv_filter->vf_filter;
		while (p->vfe_next)
		    p = p->vfe_next;
		p->vfe_next = (yyvsp[0].filterelem);
	    }
	}
#line 2006 "cfparse.c"
    break;

  case 68: /* mod: ACCEPT  */
#line 493 "cfparse.y"
        {
	    warn("Expected filter spec after accept keyword, ignored");
	}
#line 2014 "cfparse.c"
    break;

  case 69: /* mod: DENY filter  */
#line 497 "cfparse.y"
        {
	    if (!v->uv_filter) {
		struct vif_filter *v_filter;

		v_filter = calloc(1, sizeof(struct vif_filter));
		if (!v_filter) {
		    fatal("Failed allocating memory for 'struct vif_filter'");
		    return 0;
		}

		v_filter->vf_flags  = 0;
		v_filter->vf_type   = VFT_DENY;
		v_filter->vf_filter = (yyvsp[0].filterelem);

		v->uv_filter = v_filter;
	    } else if (v->uv_filter->vf_type != VFT_DENY) {
		fatal("Cannot accept and deny");
	    } else {
		struct vf_element *p;

		p = v->uv_filter->vf_filter;
		while (p->vfe_next)
		    p = p->vfe_next;
		p->vfe_next = (yyvsp[0].filterelem);
	    }
	}
#line 2045 "cfparse.c"
    break;

  case 70: /* mod: DENY  */
#line 524 "cfparse.y"
        {
		warn("Expected filter spec after deny keyword, ignored");
	}
#line 2053 "cfparse.c"
    break;

  case 71: /* mod: BIDIR  */
#line 528 "cfparse.y"
        {
	    if (!v->uv_filter) {
		fatal("bidir goes after filters");
		return 0;	/* Never reached */
	    }
	    v->uv_filter->vf_flags |= VFF_BIDIR;
	}
#line 2065 "cfparse.c"
    break;

  case 72: /* interface: ADDR  */
#line 538 "cfparse.y"
        {
	    (yyval.addr) = (yyvsp[0].addr);
	}
#line 2073 "cfparse.c"
    break;

  case 73: /* interface: STRING  */
#line 542 "cfparse.y"
        {
	    struct uvif *v;

	    /*
	     * Looks a little weird, but the orig. code was based around
	     * the addresses being used to identify interfaces.
	     */
	    v = config_find_ifname((yyvsp[0].ptr));
	    if (!v) {
		warn("phyint %s not available, continuing ...", (yyvsp[0].ptr));
		(yyval.addr) = 0;
	    } else
		(yyval.addr) = v->uv_lcl_addr;
	}
#line 2092 "cfparse.c"
    break;

  case 74: /* addrname: ADDR  */
#line 559 "cfparse.y"
        {
	    (yyval.addr) = (yyvsp[0].addr);
	}
#line 2100 "cfparse.c"
    break;

  case 75: /* addrname: STRING  */
#line 563 "cfparse.y"
        {
	    struct sockaddr_in *sin;
	    struct addrinfo *result;
	    struct addrinfo hints;
	    int rc;

	    memset(&hints, 0, sizeof(struct addrinfo));
	    hints.ai_family = AF_INET;
	    hints.ai_socktype = SOCK_DGRAM;

	    rc = getaddrinfo((yyvsp[0].ptr), NULL, &hints, &result);
	    if (rc) {
		fatal("No such host %s", (yyvsp[0].ptr));
		return 0;	/* Never reached */
	    }

	    if (result->ai_next) {
		freeaddrinfo(result);
		fatal("Hostname %s does not %s", (yyvsp[0].ptr), "map to a unique address");
	    }

	    sin = (struct sockaddr_in *)result->ai_addr;
	    (yyval.addr)  = sin->sin_addr.s_addr;

	    freeaddrinfo(result);
	}
#line 2131 "cfparse.c"
    break;

  case 76: /* bound: boundary  */
#line 591 "cfparse.y"
        {
	    (yyval.addrmask) = (yyvsp[0].addrmask);
	}
#line 2139 "cfparse.c"
    break;

  case 77: /* bound: STRING  */
#line 595 "cfparse.y"
        {
	    int i;

	    for (i = 0; i < numbounds; i++) {
		if (!strcmp(boundlist[i].name, (yyvsp[0].ptr))) {
		    (yyval.addrmask) = boundlist[i].bound;
		    break;
		}
	    }

	    if (i == numbounds)
		fatal("Invalid boundary name %s", (yyvsp[0].ptr));
	}
#line 2157 "cfparse.c"
    break;

  case 78: /* boundary: ADDRMASK  */
#line 611 "cfparse.y"
        {
#ifdef ALLOW_BLACK_HOLES
	    if (!allow_black_holes)
#endif
		if ((ntohl((yyvsp[0].addrmask).addr) & 0xff000000) != 0xef000000) {
		    fatal("Boundaries must be 239.x.x.x, not %s/%d",
			  inet_fmt((yyvsp[0].addrmask).addr, s1, sizeof(s1)), (yyvsp[0].addrmask).mask);
		}
	    (yyval.addrmask) = (yyvsp[0].addrmask);
	}
#line 2172 "cfparse.c"
    break;

  case 79: /* addrmask: ADDRMASK  */
#line 623 "cfparse.y"
                                { (yyval.addrmask) = (yyvsp[0].addrmask); }
#line 2178 "cfparse.c"
    break;

  case 80: /* addrmask: ADDR  */
#line 624 "cfparse.y"
                                { (yyval.addrmask).addr = (yyvsp[0].addr); (yyval.addrmask).mask = 0; }
#line 2184 "cfparse.c"
    break;

  case 81: /* filter: filtlist  */
#line 627 "cfparse.y"
                                { (yyval.filterelem) = (yyvsp[0].filterelem); }
#line 2190 "cfparse.c"
    break;

  case 82: /* filter: STRING  */
#line 628 "cfparse.y"
                                { fatal("named filters no implemented yet"); }
#line 2196 "cfparse.c"
    break;

  case 83: /* filtlist: filtelement  */
#line 631 "cfparse.y"
                                { (yyval.filterelem) = (yyvsp[0].filterelem); }
#line 2202 "cfparse.c"
    break;

  case 84: /* filtlist: filtelement filtlist  */
#line 632 "cfparse.y"
                                { (yyvsp[-1].filterelem)->vfe_next = (yyvsp[0].filterelem); (yyval.filterelem) = (yyvsp[-1].filterelem); }
#line 2208 "cfparse.c"
    break;

  case 85: /* filtelement: filtelem  */
#line 635 "cfparse.y"
                                { (yyval.filterelem) = (yyvsp[0].filterelem); }
#line 2214 "cfparse.c"
    break;

  case 86: /* filtelement: filtelem EXACT  */
#line 636 "cfparse.y"
                                { (yyvsp[-1].filterelem)->vfe_flags |= VFEF_EXACT; (yyval.filterelem) = (yyvsp[-1].filterelem); }
#line 2220 "cfparse.c"
    break;

  case 87: /* filtelem: ADDRMASK  */
#line 640 "cfparse.y"
        {
	    struct vf_element *vfe;

	    vfe = calloc(1, sizeof(struct vf_element));
	    if (!vfe) {
		fatal("Failed allocating memory for 'struct vf_element'");
		return 0;
	    }

	    vfe->vfe_addr = (yyvsp[0].addrmask).addr;
	    VAL_TO_MASK(vfe->vfe_mask, (yyvsp[0].addrmask).mask);
	    vfe->vfe_flags = 0;
	    vfe->vfe_next = NULL;

	    (yyval.filterelem) = vfe;
	}
#line 2241 "cfparse.c"
    break;


#line 2245 "cfparse.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 656 "cfparse.y"

static void fatal(const char *fmt, ...)
{
    va_list ap;
    char buf[MAXHOSTNAMELEN + 100];

    va_start(ap, fmt);
    vsnprintf(buf, sizeof(buf), fmt, ap);
    va_end(ap);

    logit(LOG_ERR, 0, "%s:%d: %s", config_file, lineno, buf);
}

static void warn(const char *fmt, ...)
{
    va_list ap;
    char buf[200];

    va_start(ap, fmt);
    vsnprintf(buf, sizeof(buf), fmt, ap);
    va_end(ap);

    logit(LOG_WARNING, 0, "%s:%d: %s", config_file, lineno, buf);
}

static void yyerror(char *msg)
{
    logit(LOG_ERR, 0, "%s:%d: %s", config_file, lineno, msg);
}

static char *next_word(void)
{
    static char buf[1024];
    static char *p = NULL;
    char *q;

    while (1) {
        if (!p || !*p) {
            lineno++;
            if (fgets(buf, sizeof(buf), fp) == NULL)
                return NULL;
            p = buf;
        }

        while (*p && (*p == ' ' || *p == '\t'))	/* skip whitespace */
            p++;

        if (*p == '#') {
            p = NULL;		/* skip comments */
            continue;
        }

        q = p;
        while (*p && *p != ' ' && *p != '\t' && *p != '\n')
            p++;		/* find next whitespace */
        *p++ = '\0';	/* null-terminate string */

        if (!*q) {
            p = NULL;
            continue;	/* if 0-length string, read another line */
        }

        return q;
    }
}

/*
 * List of keywords.  Must have an empty record at the end to terminate
 * list.  If a second value is specified, the first is used at the beginning
 * of the file and the second is used while parsing interfaces (e.g. after
 * the first "phyint" or "tunnel" keyword).
 */
static struct keyword {
	char	*word;
	int	val1;
	int	val2;
} words[] = {
	{ "cache_lifetime",	CACHE_LIFETIME, 0 },
	{ "cache-lifetime",	CACHE_LIFETIME, 0 },
	{ "prune_lifetime",	PRUNE_LIFETIME,	PRUNE_LIFETIME2 },
	{ "prune-lifetime",	PRUNE_LIFETIME,	PRUNE_LIFETIME2 },
	{ "igmp-query-interval", QUERY_INTERVAL, 0 },
	{ "igmp-query-last-member-interval", QUERY_LAST_MEMBER_INTERVAL, 0 },
	{ "igmp-robustness",    IGMP_ROBUSTNESS, 0 },
	{ "no",                 NO, 0 },
	{ "pruning",		PRUNING, 0 },
	{ "phyint",		PHYINT, 0 },
	{ "tunnel",		TUNNEL, 0 },
	{ "disable",		DISABLE, 0 },
	{ "enable",		ENABLE, 0 },
	{ "metric",		METRIC, 0 },
	{ "advert_metric",	ADVERT_METRIC, 0 },
	{ "advert-metric",	ADVERT_METRIC, 0 },
	{ "threshold",		THRESHOLD, 0 },
	{ "rate_limit",		RATE_LIMIT, 0 },
	{ "rate-limit",		RATE_LIMIT, 0 },
	{ "force_leaf",		FORCE_LEAF, 0 },
	{ "force-leaf",		FORCE_LEAF, 0 },
	{ "router-alert",	ROUTER_ALERT, 0 },
	{ "srcrt",		SRCRT, 0 },
	{ "sourceroute",	SRCRT, 0 },
	{ "boundary",		BOUNDARY, 0 },
	{ "netmask",		NETMASK, 0 },
	{ "igmpv1",		IGMPV1, 0 },
	{ "igmpv2",		IGMPV2, 0 },
	{ "igmpv3",		IGMPV3, 0 },
	{ "static-group",	STATIC_GROUP, 0 },
	{ "altnet",		ALTNET, 0 },
	{ "name",		NAME, 0 },
	{ "accept",		ACCEPT, 0 },
	{ "deny",		DENY, 0 },
	{ "exact",		EXACT, 0 },
	{ "bidir",		BIDIR, 0 },
	{ "allow_nonpruners",	ALLOW_NONPRUNERS, 0 },
	{ "allow-nonpruners",	ALLOW_NONPRUNERS, 0 },
#ifdef ALLOW_BLACK_HOLES
	{ "allow_black_holes",	BLACK_HOLE, 0 },
	{ "allow-black-holes",	BLACK_HOLE, 0 },
#endif
	{ "noflood",		NOFLOOD, NOFLOOD2 },
	{ "notransit",		NOTRANSIT, 0 },
	{ "blaster",		BLASTER, 0 },
	{ "rexmit_prunes",	REXMIT_PRUNES, REXMIT_PRUNES2 },
	{ "rexmit-prunes",	REXMIT_PRUNES, REXMIT_PRUNES2 },
	{ "passive",		PASSIVE, 0 },
	{ "beside",		BESIDE, 0 },
#if 0 /* Removed SNMP support */
	{ "sysName",		SYSNAM, 0 },
	{ "sysContact",		SYSCONTACT, 0 },
	{ "sysVersion",		SYSVERSION, 0 },
	{ "sysLocation",	SYSLOCATION, 0 },
#endif
	{ NULL,			0, 0 }
};


static int yylex(void)
{
    struct keyword *w;
    uint32_t addr, n;
    char *q;

    q = next_word();
    if (!q)
        return 0;

    for (w = words; w->word; w++) {
        if (!strcmp(q, w->word))
            return (state && w->val2) ? w->val2 : w->val1;
    }

    if (!strcmp(q,"on") || !strcmp(q,"yes")) {
        yylval.num = 1;
        return BOOLEAN;
    }

    if (!strcmp(q,"off") || !strcmp(q,"no")) {
        yylval.num = 0;
        return BOOLEAN;
    }

    if (!strcmp(q,"default")) {
        yylval.addrmask.mask = 0;
        yylval.addrmask.addr = 0;
        return ADDRMASK;
    }

    if (sscanf(q,"%[.0-9]/%u%c",s1,&n,s2) == 2) {
	addr = inet_parse(s1,1);
        if (addr != 0xffffffff) {
            yylval.addrmask.mask = n;
            yylval.addrmask.addr = addr;
            return ADDRMASK;
        }
        /* fall through to returning STRING */
    }

    if (sscanf(q,"%[.0-9]%c",s1,s2) == 1) {
	addr = inet_parse(s1, 4);
        if (addr != 0xffffffff) {
	    if (inet_valid_host(addr)) {
		yylval.addr = addr;
		return ADDR;
	    }
	    if (inet_valid_group(addr)) {
		yylval.addr = addr;
		return GROUP;
	    }
        }
    }

    if (sscanf(q,"0x%8x%c", &n, s1) == 1) {
        yylval.addr = n;
        return ADDR;
    }

    if (sscanf(q,"%u%c",&n,s1) == 1) {
        yylval.num = n;
        return NUMBER;
    }

    yylval.ptr = q;

    return STRING;
}

void config_vifs_from_file(void)
{
    TAILQ_INIT(&scrap.uv_static);
    TAILQ_INIT(&scrap.uv_groups);
    TAILQ_INIT(&scrap.uv_neighbors);

    order = 0;
    state = 0;
    numbounds = 0;
    lineno = 0;

    fp = fopen(config_file, "r");
    if (!fp) {
        if (errno != ENOENT)
            logit(LOG_ERR, errno, "Cannot open %s", config_file);
        return;
    }

    yyparse();

    fclose(fp);
}

/**
 * Local Variables:
 *  indent-tabs-mode: t
 *  c-file-style: "cc-mode"
 * End:
 */
